int
our_input(void)
{
    return (MY_INPUT());
}

int
argmatch(const char *option, const char *s, size_t minmatch)
{ /* return 1 if s matches at least minmatch chars of option, 0 otherwise */
    size_t noption, ns;

    noption = strlen(option);
    ns = strlen(s);
    if ((ns <= noption) && (ns >= minmatch))
	return (strncmp(option, s, ns) == 0);
    else
	return (0);
}

void
copyright(void)
{
    (void)printf("This is free software; see the source for copying conditions.  There is NO\n");
    (void)printf("warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n");
    (void)printf("\n");
    (void)printf("This program is covered by the GNU General Public License (GPL), version 2 or\n");
    (void)printf("later, available as the file COPYING in the program source distribution, and on\n");
    (void)printf("the Internet at\n");
    (void)printf("\thttp://www.gnu.org/licenses/licenses.html#GPL\n");
    (void)printf("\thttp://www.gnu.org/copyleft/gpl.html\n");
}


void
usage(const char *program)
{
    (void)printf("\nUsage: %s [--?] [--author] [--copyright] [--help] [--version] < infile >outfile\n\n",
		 program);
}


int
main(int argc, char *argv[])
{
    int k;
    const char *progname;
    const char *s;

    s = strrchr(argv[0], '/');
    progname = (s == (char *)NULL) ? argv[0] : s + 1;

    for (k = 1; k < argc; ++k)
    {
	s = argv[k];
	if ((s[0] == '-') && (s[1] == '-') && (s[2] != '\0'))
	    s++;
	if (argmatch("-author", s, 2))
	    (void)printf("%s\n", PACKAGE_BUGREPORT);
	else if (argmatch("-copyright", s, 2))
	    copyright();
	else if (argmatch("-?", s, 2) || argmatch("-help", s, 2))
	    usage(progname);
	else if (argmatch("-version", s, 2))
	{
	    (void)printf("%s (%s) %s\n\n", progname, PACKAGE_NAME, PACKAGE_VERSION);
	    (void)printf("Send problem reports to %s.\n\n", PACKAGE_BUGREPORT);
	    copyright();
	}
	else
	{
	    (void)printf("Unrecognized option: [%s]\n", argv[k]);
	    usage(progname);
	    return (EXIT_FAILURE);
	}
    }
    if (argc < 2)
        yylex();
    return (EXIT_SUCCESS);
}
